 	section ".data"
 	include "OS.h"

 xdef Play4Channel
 
Play4Channel:
	;Sauvegarde des registres...
	movem.l	d0/d1/d3-d7/a0/a5,-(a7)
	
	;Detection de la calculatrice pour la touche [ESC] 0=TI-89, 1=TI-92 Plus, 2=V200
	;-------------------------------------------------------------------------------
	movem.l	a1,-(a7)			;Sauvegarde a1
	move.l $C8,a0				;Addresse pour vrifier si TI-89 ou TI-92 Plus
	move.b	#1,calc				;Prdfinis comme TI-92 Plus
	move.l	a0,d1				;Prpare d1
	and.l #$400000,d1			;Si ~0 alors TI-92 Plus sinon TI-89 ou V200
	bne	__calculator			;Dans cas TI-92 Plus alors Fin
	move.b	#0,calc				;Prdfinis comme TI-89
	move.l $2F*4(a0),a1			;Prpare condition
	cmp.b	#200,2(a1)			;Si 200 alors TI-89
	bcs	__calculator			;Donc Fin
	move.b	#2,calc				;Donc V200
__calculator:
	movem.l	(a7)+,a1			;Restaure a1

	;Detection de l'Hardware
	;-----------------------

	move.l	$C8,d0
	and.l	#$600000,d0
	move.l	d0,a0
	move.l	$104(a0),a0
	move.w	#1,Hardware
	sub.l	a0,d0
	cmp.l	#-$10000,d0
	bls.b	__hardware
	cmp.w	#$16,(a0)
	bls.b	__hardware
	;move.l	#16(a0),Hardware
	move.w	#2,Hardware
__hardware:
	cmp.w	#1,Hardware
	bne	PlaySound
	muls	#10,d2				;Adaptation du HW2 sur HW1	12 Mhz, 10 Mhz
	divs	#12,d2				;Est qui vaut  1.2	

PlaySound:
	;Enregistre les donnes
	move.w	#0,tps1
	move.w	#0,tps2
	move.w	#0,tps3
	move.w	#0,tps4
	
	muls	#30,d2				;Correspond  une				;Etalonnage de la boucle tempo
	divs	#51,d2				;division
		
	move.w	d2,unittps
	clr.l	d0
	
	;move.w	#$700,d0			;Dplace le chiffre 1792 pour
	;trap	#1				;dsactiver l'auto-interruption n1
	;move.w	d0,-(sp)			;Enregistre l'handle de int1 dans d0
	
	lea	TblFreq(PC),a0			;Charge la liste des frquences dans a0
	;lea 	morc1(PC),a1			;Charge les donnes du morceau 1 dans a1
	;lea	morc2(PC),a2			;Charge les donnes du morceau 2 dans a2
	
	bset	#6,($60000C)			;Initialise le port IO soit le byte 6 mie  1
	bclr	#0,($60000E)			;Initialise l'couteur gauche
	bclr	#1,($60000E)			;Initialise l'couteur droit
	
	move.b	#1,duree1			;Initialize duree1  1
	move.b	#1,duree2		 	;Initialize duree2  2
	move.b	#1,duree3			;Initialize duree3				;""
	move.b	#1,duree4			;Initialize duree4				;""
	
boucle:
	
;charge1
;touche [ESC] enfonc ?
	cmp	#0,calc				;Si TI-89
	beq	key_89				;Aller  key_89
	bne	key_92				;sinon key_92

key_89: move.w	#6,d0				;Sur TI-89, detection touche [ESC]
	bsr	masque				;Clavier en bas niveau
	btst.b	#0,d0
	beq	fin
	bne	suite

key_92:	move.w	#8,d0				;dplace 8 dans d0
	bsr	masque				;Va  masque pour lire en bas niveau le clavier
	btst.b	#6,d0				;Teste le bit 6 du clavier
	beq	fin				;Si le bit 6 est  1 soit touche ESC press alors aller  fin
	
;----------------------
	sub.b	#1,duree1
	cmp.b	#0,duree1				;Si duree1!=0 alors
	bne	cont_1					;aller  cont_1
	
suite:	cmp.b	#255,(a1)				;Si channel1=255 Fin			
	beq	fin				
	clr.l	d0					;Efface Int1 sav
	move.b	(a1)+,d0				;Frquence	channel1
	move.b	(a1)+,d2				;Dure		channel1
	move.b	#1,d1					;Voie1		
	bsr	decode
	move.w	tps1,d7					;D7=tps1	


cont_1:
	sub.b	#1,duree3
	cmp.b	#0,duree3				;Si duree3!=0 va cont_1
	bne	cont_3

	cmp.b	#255,(a3)				;Si channel3=255 Fin
	beq	fin
	clr.l	d0					;Efface Int1 sav
	move.b	(a3)+,d0				;Frquence	channel3
	move.b	(a3)+,d2				;Dure		channel3
	move.b	#3,d1					;Voie3
	bsr	decode
	move.w	tps3,d5

	btst	#1,($60000E)				;Si fil blanc=1 plus1
	bne	plus1	
	bclr	#0,($60000E)				;Vide couteur gauche
	bra	cont_3					;Va  cont_1

plus1:
	bset	#0,($60000E)				;Initialize couteur gauche


cont_3:
	sub.b	#1,duree2				
	cmp.b	#0,duree2				;Si duree2!=0 va cont_2
	bne	cont_4					

	cmp.b	#255,(a2)				;Si channel2=255 Fin
	beq	fin					
	clr.l	d0					;Efface Int1 sav
	move.b	(a2)+,d0				;Frquence	channel2
	move.b	(a2)+,d2				;Dure		channel2
	move.b	#2,d1					;Voie2
	bsr	decode
	move.w	tps2,d6					;D6=tps2
	
cont_4:

	sub.b	#1,duree4
	cmp.b	#0,duree4				;Si duree4!=0 va cont_4
	bne	fin_cont
	
	cmp.b	#255,(a4)				;Si channel4=255 fin
	beq	fin
	clr.l	d0					;Efface Int1 sav
	move.b	(a4)+,d0				;Frquence	channel4
	move.b	(a4)+,d2				;Dure		channel4
	move.b	#4,d1					;Voie4
	bsr	decode
	move.w	tps4,d4					;D5=tps4


	btst	#0,($60000E)
	bne	plus2			
	bclr	#1,($60000E)
	bra	fin_cont

plus2:
	bset	#1,($60000E)				;Initialize couteur droit
	


fin_cont:
	
	move.w	unittps,d3				;D4=Tempo
	
;cas d'une pause
	cmp.w	tps1,d3					;Si tps1>Tempo alors paspause1
	bhi	paspause1
	move.w	tps1,d7					;D7=tps1

paspause1:
	cmp.w	tps2,d3					;Si tps2>Tempo alors paspause2 
	bhi	paspause2
	move.w	tps2,d6					;D6=tps2

paspause2:
	cmp.w	tps3,d3					;Si tps3>Tempo alors paspause3 		
	bhi	paspause3
	move.w	tps3,d5					;D5=tps3
	
paspause3:
	cmp.w	tps4,d3					;Si tps4>Tempo alors paspause4 
	bhi	paspause4
	move.w	tps4,d4					;D4=tps4
	
paspause4:


;-----------------------------------------	
;joue le son pendant une dure lmentaire
bcle_son:
	dbra.w	d7,son_1
	move.w	tps1,d7
	bchg	#0,($60000E)
	
son_1:
	dbra.w	d6,son_2
	move.w	tps2,d6
	bchg	#1,($60000E)

son_2:
	dbra.w	d5,son_3
	move.w	tps3,d5
	bchg	#0,($60000E)
	
son_3:
	dbra.w	d4,son_4
	move.w	tps4,d4
	bchg	#1,($60000E)

son_4:
	dbra	d3,bcle_son
	bra	boucle
	

fin:
	bclr	#0,($60000E)
	bclr	#1,($60000E)
	move.b	#$8D,($60000C)
	
	;move.w	(sp)+,d0
	;trap	#1
	movem.l	(a7)+,d0/d1/d3-d7/a0/a5
	rts
	
;******************************************************************
;Decode une valeur de note
;------------------------------------------------------------------
;d0=valeur code (1er chiffre hexa=octave,2me=note)
;d1=voie (1 ou 2)
;d2=dure
; =>d0=frquence
;******************************************************************

decode:
	move.l	d1,-(a7)
	cmp.w	#0,d0
	beq	pause
	
	move.l	d0,d1
	ror.l	#4,d1
	
	sub.w	#1,d1
	mulu.w	#12,d1
	and.w	#$0f,d0
	sub.w	#1,d0
	add.w	d1,d0
	
	rol.l	#1,d0
	move.l	a0,a5
	
	add.w	d0,a5
	clr.l	d0
	move.w	(a5),d0
	bra	voie

pause:
	move.w	unittps,d0
	add.w	#1,d0

voie:
	move.l	(a7)+,d1
	cmp.b	#1,d1
	beq	voie1
	
	cmp.b	#2,d1
	beq 	voie2
	
	cmp.b	#3,d1
	beq	voie3
	bne	voie4
	
voie1:	move.w	d0,tps1
	move.b	d2,duree1
	rts

voie2:	move.w	d0,tps2
	move.b	d2,duree2
	rts
	
voie3:	move.w	d0,tps3
	move.b	d2,duree3
	rts

voie4:	move.w	d0,tps4
	move.b	d2,duree4
	rts

;********************************************
;masque une ligne du clavier
;--------------------------------------------
;d0=ligne -> d0=rponse
;********************************************
masque:
	movem.l	d1,-(a7)
	move.w	#$FFFE,d1
	rol.w	d0,d1
	clr.w	d0
	move.w	d1,($600018)
	nop
	nop
	nop
	nop
	nop
	nop
	move.b	($60001B),d0
	movem.l	(a7)+,d1
	RTS
	
;----------------------------------------------------------------------------
;Donnes pour la libraire PolySnd
;----------------------------------------------------------------------------
	
TblFreq: dc.w	$011,$012,$013,$014,$015,$016,$017,$019,$01a,$01c,$01d,$01f
	 dc.w   $021,$023,$025,$027,$029,$02c,$02e,$031,$034,$037,$03a,$03e
	 dc.w   $041,$045,$049,$04e,$052,$057,$05c,$062,$068,$06e,$075,$07b
	 dc.w   $083,$08b,$093,$09c,$0a5,$0af,$0b9,$0c4,$0d0,$0dc,$0e9,$0f7
	 dc.w   $106,$115,$126,$137,$14a,$15d,$172,$188,$19f,$1b8,$1d2,$1ee
	 dc.w   $20b,$22a,$24b,$26e,$293,$2ba,$2e4,$310,$33f,$370,$3a4,$3dc
	 dc.w   $417,$455,$497,$4dd,$527,$575,$5c8,$620,$67d,$6e0,$749,$7b8
	 dc.w   $82d,$8a9,$92d,$9b9,$a4d,$aea,$b90,$c40,$cfa,$dc0,$e91,$f6f	
	 EVEN
	
duree1	dc.b	$0
	EVEN
duree2	dc.b	$0
	EVEN
duree3	dc.b	$0
	EVEN
duree4	dc.b	$0
	EVEN
tps1	dc.w	$0
	EVEN
tps2	dc.w	$0
	EVEN
tps3	dc.w	$0
	EVEN
tps4	dc.w	$0
	EVEN
	
unittps	dc.w	$0
	EVEN
	
calc	dc.b	0
	EVEN
Hardware dc.w	0
	EVEN
	end